



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Codeforces 838A - Binary Blocks(二维前缀和+容斥)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Codeforces 838A - Binary Blocks(二维前缀和+容斥)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-20 18:18:30 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><a href="http://codeforces.com/problemset/problem/838/A" rel="external nofollow noreferrer"><strong>838A - Binary Blocks</strong></a></p>
<p><strong>思路：求一下前缀和，然后就能很快算出每一小正方块中1的个数了，0的个数等于k*k减去1的个数，两个的最小值就是要加进答案的值。</strong></p>
<p><strong>代码：</strong></p>
<div>
<pre class="prettyprint linenums">#include&lt;bits/stdc++.h&gt;<br />
using namespace std;<br />
#define ll long long<br />
#define pb push_back<br />
#define mem(a,b) memset((a),(b),sizeof(a))<br />
const int INF=0x3f3f3f3f;<br />
const int N=;<br />
char mp[N][N];<br />
int Mp[N][N]={};

int main()<br />
{<br />
    ios::sync_with_stdio(false);<br />
    cin.tie();<br />
    int n,m;<br />
    cin&gt;&gt;n&gt;&gt;m;<br />
    for(int i=;i&lt;=n;i++)cin&gt;&gt;mp[i]+;<br />
    for(int i=;i&lt;=n;i++)<br />
    {<br />
        for(int j=;j&lt;=m;j++)<br />
        Mp[i][j]=mp[i][j]-'';<br />
    }<br />
    for(int i=;i&lt;N;i++)<br />
    {<br />
        for(int j=;j&lt;N;j++)<br />
        {<br />
            Mp[i][j]+=Mp[i-][j]+Mp[i][j-]-Mp[i-][j-];<br />
        }<br />
    }<br />
    int minn=min(n,m);<br />
    int ans=INF;

    for(int i=;i&lt;=minn;i++)<br />
    {<br />
        bool flag=true;<br />
        int x=n/i;<br />
        int y=m/i;<br />
        if(n%i)x++;<br />
        if(m%i)y++;<br />
        int cnt=;<br />
        for(int j=;j&lt;=x;j++)<br />
        {<br />
            for(int k=;k&lt;=y;k++)<br />
            {<br />
                if(j==&amp;&amp;k==)<br />
                {<br />
                    int t=Mp[j*i][k*i];<br />
                    cnt+=min(i*i-t,t);<br />
                }<br />
                else<br />
                {<br />
                    int t=Mp[j*i][k*i]+Mp[j*i-i][k*i-i]-Mp[j*i][k*i-i]-Mp[j*i-i][k*i];<br />
                    cnt+=min(i*i-t,t);<br />
                }<br />
            }<br />
        }<br />
        ans=min(ans,cnt);<br />
    }<br />
    printf("%d\n",ans);<br />
    return ;<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlo5eqo.html">C&num;开发微信门户及应用&lpar;39&rpar;--使用微信JSSDK实现签到的功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pwngd8.html">mysql 数据表中查找重复记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rm2wr8.html">GitHub官方介绍（中文翻译）</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlr3n1q.html">数据库开发及ADO&period;NET</a>
		</li>
						<li><a href="https://www.batexi.com/a/390gj4j8.html">iOS开发拓展篇-XMPP简单介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gloezq.html">简单几何&lpar;凸包&rpar; POJ 2187 Beauty Contest</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm1ygl9.html">hdu5514Frogs（2015ACM-ICPC沈阳赛区F题）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd0xrl8.html">android app性能优化大汇总（google官方Android性能优化典范 - 第1季）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xg4jw9.html">jqgrid单元格设置空值的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv7l4oq.html">GAC write failed when upgrade with InstallShield</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd3o7y8.html">C&num; byte&lbrack;&rsqb;与char&lbrack;&rsqb;、string与char&lbrack;&rsqb;、byte&lbrack;&rsqb; 与 string 互转</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wr7zlq.html">Android 初步</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojj6zlq.html">PHP微信SDK&mdash;&mdash;Zebra-Wechat</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp31evq.html">iOS - CALayer 绘图层</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgvwk48.html">Centos发布java的war包后，无法访问发布的工程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvokxy8.html">Method not found&colon; &excl;&excl;0&lbrack;&rsqb; System&period;Array&period;Empty&lpar;&rpar;错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gw5ymq.html">HAWQ配置之客户端访问</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o12nw5q.html">centos通过Supervisor配置&period;net core守护进程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj664r9.html">ANY 和 IN  查询价格大于或等于&amp;quot&semi;超级本&amp;quot&semi;价格的商品，并且按价格降序排列</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy3l0xq.html">tensorflow入门笔记（二） 滑动平均模型</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9jmnmzw9.html">Bootstrap学习笔记-布局</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2o20z8.html">认识GMT和UTC时间-附带地理知识</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkrryv8.html">20154312《网络对抗》Exp2 后门原理与实践</a>
			</li>
						<li><a href="https://www.batexi.com/a/8em55ox9.html">Asp&period;net MVC 通过自定义ControllerFactory实现构造器注入</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o4vvgpq.html">sql when null 判断</a>
			</li>
						<li><a href="https://www.batexi.com/a/953mmo08.html">IntelliJ IDEA 编译Java程序出现 &amp;&num;39&semi;Error&colon;java&colon; 无效的源发行版&colon; 9&amp;&num;39&semi;  解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kon507q.html">Kettle 学习导航帖整理</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnn25e2q.html">ajax请求头设置 &vert; header 传token</a>
			</li>
						<li><a href="https://www.batexi.com/a/902jeomq.html">20145316许心远《网络对抗》MSF基础应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2km213q.html">oracle中如何判断blob类型字段是否为空</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
